package voip;

public class ByteOp {
	public static final byte[] intToByte(int n) {
		return new byte[] { (byte) (n >>> 24), (byte) (n >>> 16),
				(byte) (n >>> 8), (byte) n };
	}

	public static int byteArrayToInt(byte[] b) {
		return (b[0] << 24) + ((b[1] & 0xFF) << 16) + ((b[2] & 0xFF) << 8)
				+ (b[3] & 0xFF);
	}

	public static byte[] longToBytes(long l) {
		byte[] data = new byte[8];
		for (int i = data.length - 1; i >= 0; i--) {
			data[i] = (byte) (l & 0xFF);
			l >>= 8;
		}

		return data;
	}

	public static long getLong(byte[] data, int offset, int length) {
		long l = 0;
		int i = 0;
		while (i < length) {
			l <<= 8;
			l += data[offset + i] & 0xFF;
			i++;
		}
		return l;
	}
	
}
