package voip;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.SocketException;
import java.util.concurrent.ArrayBlockingQueue;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.SourceDataLine;

public class Play extends Thread {
	protected DatagramSocket conexao;
	protected DatagramPacket pacote;

	protected long expectedTime;
	protected boolean vive;
	ArrayBlockingQueue<byte[]> buffer;
	long r; // instante que o pacote foi gerado pelo remetente
	long t; // instante que o pacote  recebido
	long p; // instante que o pacote  reproduzido
	int d = 0; // atraso de rede fim a fim
	int v = 0; // desvio mdio do atraso
	long playedTimestamp;
	int bufferSize;
	int length;

	public Play(ArrayBlockingQueue<byte[]> buffer, DatagramSocket conexao,
			int buffersize) {
		this.buffer = buffer;
		this.conexao = conexao;
		this.bufferSize = buffersize;
	}

	private void playAudio() throws SocketException, InterruptedException {

		try {
			AudioFormat format = getFormat();
			DataLine.Info info = new DataLine.Info(SourceDataLine.class, format);
			SourceDataLine line = (SourceDataLine) AudioSystem

			.getLine(info);
			line.open(format);
			line.start();
			long timestamp;
			expectedTime = 0;

			byte[] data = new byte[bufferSize + 12];

			vive = true;
			while (vive) {

				try {
					pacote = new DatagramPacket(data, data.length);
					conexao.receive(pacote);
					data = pacote.getData();
					timestamp = ByteOp.getLong(data, 4, 8);

					 t = System.currentTimeMillis();

					 r = ByteOp.getLong(data, 4, 8);
					 d = (int) ((1 - 0.01) * d + 0.01 * (r - t));
					 v = (int) ((1 - 0.01) * v + 0.01 * Math.abs(r - t -
					 d));
					 p = t + d + 4;
					 
					if (timestamp >= expectedTime) {

						buffer.add(data);
						data = buffer.remove();
						length = ByteOp.byteArrayToInt(new byte[] { data[0],
								data[1], data[2], data[3] });
						line.write(data, 12, length);
					}

				} catch (Exception e) {

				}
			}
			line.close();

		} catch (LineUnavailableException e) {

		}
	}

	private AudioFormat getFormat() {
		AudioFormat derp = new AudioFormat(8000, 16, 1, true, true);
//		AudioFormat derp = new AudioFormat(AudioFormat.Encoding.PCM_SIGNED, 8000, 8, 1, 1, 8000, false);
		return derp;

	}

	@Override
	public void run() {
		try {
			this.playAudio();

		} catch (SocketException e) {
			e.printStackTrace();
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	public void kill() {
		this.vive = false;
	}
}